package TCarma_phylo_fasta;
#
#  Copyright (C) 2007 CeBiTec, Bielefeld University
#  Written by Wolfgang Gerlach.
#  The original version (CARMA 1.2) was developed by Lutz Krause.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  version 2 as published by the Free Software Foundation.
#
#  This file is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this file; see the file LICENSE.  If not, write to
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.
#

use strict;
use warnings;

#use lib '/homes/wgerlach/carma/share/perl';

#use Getopt::Std;
#use File::Basename;
#use POSIX qw(tmpnam);

use DBI;
use TCommon;



use Tree;
use Bio::SearchIO;
use Cwd;
use IO::Handle;

use DNAUtils;

use TConfigs;
use TCarma_phylo;
1;



sub carma_phylo_fasta{
	my ($fasta_file, $single_seqs_with_pfam_hit) = @_;
	
	# If $fasta_file is a directory parse each fasta file in that directory
	if(-d $fasta_file){
		my $indir = $fasta_file;

		print STDERR "Reading input files ... " if $main::opt_v;
		opendir DIR, "$indir" || die "ERROR: Could not open directory $indir:$!\n";
	
		my @allentries = grep /\.out$/, grep !/^\.\.?$/, readdir DIR;
		close DIR;
	
		unless(@allentries){
			   print STDERR "ERROR: no files with suffix .out in directory $indir\n";
			   exit 1;
		} 
		print STDERR "Done.\nParsing files ... " if $main::opt_v;

		# parse each fasta file in directory
		foreach (@allentries){
				die "ERROR while parsing fasta file $indir/$_!!!\n" 
					   unless &TCommon::parse_fasta("$indir/$_",
							 \&TCarma_phylo::_add_seq_with_pfam_hit,
							 $single_seqs_with_pfam_hit, $main::opt_f,$main::opt_g,$main::opt_n,$main::opt_v);

			 }
			 print STDERR "Done.\n" if $main::opt_v;
		 }
		 
	elsif(-e $fasta_file){
		
			die "ERROR 1 while parsing file $fasta_file!\n"
				unless &TCommon::parse_fasta($fasta_file,
							\&TCarma_phylo::_add_seq_with_pfam_hit,
							$single_seqs_with_pfam_hit,$main::opt_f,$main::opt_g,$main::opt_n,$main::opt_v);

	} else{
		print STDERR "ERROR: File or directory \"$fasta_file\" does not exist!\n";
		exit 1;
	}


	 # remove fasta file if it is a temporary file, nooooooo! wrong place
	#unlink $fasta_file unless ($main::opt_t);
	
}
